###============================================================
##      Ubuntu 18.04 Apache NGINX Reverse Proxy Additional Domain Installer
###============================================================
## Zet comments hieronder:
#
#
#
##=============================================================

##----------##
#    Menu    #
##----------##

echo "Domein instellen als NGINX reverse proxy of als NGINX webserver?"
PS3='Keuze:'
options=("Reverse proxy" "Webserver")
select opt in "${options[@]}"
do
    case $opt in
        "Reverse proxy")
            domain_setup=1
            break;;
        "Webserver")
            domain_setup=2
            break;;
        *) echo "Fout commando $REPLY";;
    esac
done

##----------------##
#    Pre-Config    #
##----------------##

# Set server IP variable for apache access
server_ip=$(hostname -I|cut -f1 -d ' ')

##============##
#    Apache    #
##============##

##-------------------##
#    Reverse Proxy    # 
##-------------------##

if [ $domain_setup = 1 ]; then
cat <<EOF > /etc/apache2/sites-available/"$domain.conf"
<VirtualHost *:8080>
    ServerName $domain
    ServerAlias www.$domain
    DocumentRoot /var/www/$domain/html
    <Directory /var/www/$domain/html>
        AllowOverride All
    </Directory>
</VirtualHost>
EOF
a2ensite "$domain"
fi

##===========##
#    NGINX    #
##===========##

##-------------------##
#    Reverse Proxy    # 
##-------------------##

if [ $domain_setup = 1 ]; then
cat <<EOF > /etc/nginx/sites-available/"$domain"
server {
    listen 80;

    root /var/www/$domain/html;
    index index.php index.html index.htm;

    server_name $domain www.$domain;

    #netdata here

    location / {
        proxy_pass http://$server_ip:8080;
        proxy_set_header X-Real-IP  \$remote_addr;
        proxy_set_header X-Forwarded-For \$remote_addr;
        proxy_set_header Host \$host;
        proxy_set_header X-Forwarded-Proto \$scheme;
    }

    location ~ \.(jpg|jpeg|gif|png|ico|css|zip|tgz|gz|rar|bz2|pdf|txt|tar|wav|bmp|rtf|js|flv|swf|html|htm)(\\n|\?ver=[0-9.])\$ {
        return 200;
    }

    location ~ /\.ht {
        deny all;
    }
}
EOF
fi

##---------------##
#    Webserver    #
##---------------##

if [ $domain_setup = 2 ]; then
cat <<EOF > /etc/nginx/sites-available/"$domain"
server {
    listen 80 default_server;

    root /var/www/$domain/html;
    index index.php index.html index.htm;

    server_name $domain www.$domain;
    
    #netdata here
    
    location / {
        try_files \$uri \$uri/ /index.php;
    }

    location ~ \.php\$ {
        fastcgi_pass unix:/run/php/php7.2-fpm.sock;
        include snippets/fastcgi-php.conf;
    }
}
EOF
fi
ln -s /etc/nginx/sites-available/"$domain" /etc/nginx/sites-enabled/"$domain"

##===========##
#    Other    #
##===========##

##----------------##
#    PHPMyAdmin    #
##----------------##

# Redirect phpmyadmin -> database
ln -s /usr/share/phpmyadmin /var/www/"$domain"/html/database

##-------------##
#    Netdata    #
##-------------##

if [ $netdata = 1 ]
    then
    apt install -y netdata
    sed -i 's/SEND_EMAIL="YES"/SEND_EMAIL="NO"/g' /etc/netdata/health_alarm_notify.conf
    ufw allow 19999/tcp
    sed -i 's+#netdata here+location = /netdata {\n        return 301 /netdata/;\n    }\n\n    location ~ /netdata/(?<ndpath>.*) {\n        proxy_redirect off;\n        proxy_set_header Host \$host;\n        proxy_set_header X-Forwarded-Host \$host;\n        proxy_set_header X-Forwarded-Server \$host;\n        proxy_set_header X-Forwarded-For \$proxy_add_x_forwarded_for;\n        proxy_http_version 1.1;\n        proxy_pass_request_headers on;\n        proxy_set_header Connection "keep-alive";\n        proxy_store off;\n        proxy_pass http://netdata/\$ndpath\$is_args\$args;\n    }+g' /etc/nginx/sites-available/"$domain"
    # systemctl stop netdata
    # systemctl disable netdata
fi

##-------------##
#    Certbot    #
##-------------##

certbot --nginx -n -d "$domain" -d "www.$domain" -m "$email" --hsts --redirect --no-eff-email --agree-tos
sed -i 's/ssl ipv6only/ssl http2 ipv6only/g' /etc/nginx/sites-available/"$domain"
sed -i 's/listen 443 ssl/listen 443 ssl http2/g' /etc/nginx/sites-available/"$domain"
sed -i 's#include /etc/letsencrypt/options-ssl-nginx.conf;#ssl_ciphers EECDH+CHACHA20:EECDH+AES128:RSA+AES128:EECDH+AES256:RSA+AES256:EECDH+3DES:RSA+3DES:!MD5;#g' /etc/nginx/sites-available/"$domain"

##---------------##
#    Wordpress    #
##---------------##

if [ $wordpress = 1 ]; then
    db_suffix=`expr $(ls -l /var/www | grep -c ^d) - 1`
    db_name="wp_$db_suffix"
    db_user="wp_$db_suffix"
    db_pass=$(date +%s|sha256sum|base64|head -c 32)
    mysql -u root -p"$password" -e "CREATE DATABASE "$db_name" DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;"
    mysql -u root -p"$password" -e "GRANT ALL ON "$db_name".* TO '"$db_user"'@'localhost' IDENTIFIED BY '"$db_pass"';"
    mysql -u root -p"$password" -e "FLUSH PRIVILEGES;"
    wget https://wordpress.org/latest.tar.gz -O /tmp/wp.tar.gz
    tar xzvf /tmp/wp.tar.gz -C /tmp
    mv /tmp/wordpress/wp-config-sample.php /tmp/wordpress/wp-config.php
    cp -a /tmp/wordpress/. /var/www/"$domain"/html
    WPSalts=$(wget https://api.wordpress.org/secret-key/1.1/salt/ -q -O -)
cat <<EOF > /var/www/"$domain"/html/wp-config.php
<?php
define('DB_NAME', '$db_name');
define('DB_USER', '$db_user');
define('DB_PASSWORD', '$db_pass');
define('DB_HOST', 'localhost');
define('DB_CHARSET', 'utf8');
define('DB_COLLATE', '');
#define( 'WP_SITEURL', '' );
#define( 'WP_HOME', '' );
#define( 'ALTERNATE_WP_CRON', true );
#define('DISABLE_WP_CRON', 'true');
#define('WP_CRON_LOCK_TIMEOUT', 900);
#define('AUTOSAVE_INTERVAL', 300);
define( 'WP_MEMORY_LIMIT', '256M' );
define( 'DISALLOW_FILE_EDIT', true );
#define( 'EMPTY_TRASH_DAYS', 7 );
define( 'NOBLOGREDIRECT', 'https://$domain' );
#define( 'FS_CHMOD_DIR', ( 0755 & ~ umask() ) );
#define( 'FS_CHMOD_FILE', ( 0644 & ~ umask() ) );
#define( 'WP_ALLOW_REPAIR', true );
#define( 'FORCE_SSL_ADMIN', true );
#define( 'AUTOMATIC_UPDATER_DISABLED', true );
#define( 'WP_AUTO_UPDATE_CORE', false );
$WPSalts
\$table_prefix = '$db_name';

define('WP_DEBUG', false);
if ( !defined('ABSPATH') )
	define('ABSPATH', dirname(__FILE__) . '/');

#\$memcached_servers = array(
#    'default' => array(
#        '127.0.0.1:11211'
#    )
#);
#define('WP_REDIS_HOST', '127.0.0.1');
#define('WP_REDIS_PASSWORD', '$password');
#define('WP_REDIS_PORT', '6379');
require_once(ABSPATH . 'wp-settings.php');
EOF
fi

##-----------------##
#    Opcache GUI    #
##-----------------##

wget https://raw.githubusercontent.com/amnuts/opcache-gui/master/index.php -O /var/www/"$domain"/html/opcache.php

##--------------##
#    Info.php    #
##--------------##

cat > /var/www/"$domain"/html/info.php <<- "EOF"
<?php phpinfo();
EOF

##-----------------------##
#    Html Folder Perms    #
##-----------------------##

chown -R www-data:www-data /var/www/"$domain"/html